FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Controllers/CategoriesController.cs
using FA.JustBlog.Common;
using FA.JustBlog.Core.Infrastructures;
using FA.JustBlog.Core.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace FA.JustBlog.Web.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = SD.Role_Blog_Owner + "," + SD.Role_Contributor)]
    public class CategoriesController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public CategoriesController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {

            return View();
        }

        //GET
        public IActionResult Create()
        {
            return View();
        }

        //Categorie
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(Category request)
        {
            
            if (ModelState.IsValid)
            {
                request.UrlSlug = SeoUrlHepler.FrientlyUrl(request.Name);
                this._unitOfWork.CategoryRepository.Add(request);
                _unitOfWork.SaveChange();
                TempData["success"] = "Categorie created successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Categorie created error";
            return View(request);
        }

        //GET
        public IActionResult Edit(int? id)
        {

            if (id.Value == null || id.Value == 0)
            {
                return NotFound();
            }
            var CategoryFromDbFirst = _unitOfWork.CategoryRepository.GetById(id.Value);
            if (CategoryFromDbFirst == null)
            {
                return NotFound();
            }
          
            return View(CategoryFromDbFirst);
        }

        //Categorie
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Category obj)
        {

            if (ModelState.IsValid)
            {
                obj.UrlSlug = SeoUrlHepler.FrientlyUrl(obj.Name);
                _unitOfWork.CategoryRepository.Update(obj);
                _unitOfWork.SaveChange();
                TempData["success"] = "Categorie updated successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Categorie created error";
            return View(obj);
        }



        #region API CALLS
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var productList = _unitOfWork.CategoryRepository.GetAll();
            return Json(new { data = productList });
        }

        //Categorie
        [HttpDelete]
        [Authorize(Roles = SD.Role_Blog_Owner)]
        public IActionResult Delete(int? id)
        {
            var obj = _unitOfWork.CategoryRepository.GetById(id.Value);
            if (obj == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.CategoryRepository.Delete(obj);
            _unitOfWork.SaveChange();
            return Json(new { success = true, message = "Delete Successful" });

        }
        #endregion

    }
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Controllers/PostsController.cs
using FA.JustBlog.Common;
using FA.JustBlog.Core.Infrastructures;
using FA.JustBlog.Core.Models;
using FA.JustBlog.ModelViews.PostViewModel;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace FA.JustBlog.Web.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = SD.Role_Blog_Owner+","+ SD.Role_Contributor)]
    public class PostsController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public PostsController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {
           
            return View();
        }

        //GET
       
        public IActionResult Create()
        {
            ViewBag.CategoryList = _unitOfWork.CategoryRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Name,
                Value = i.Id.ToString()
            });
            ViewBag.PublishedList = new List<SelectListItem>()
            {
                new SelectListItem() { Text = "True", Value = true.ToString(), Selected=true },
                new SelectListItem() { Text = "False", Value = false.ToString(), Selected=false },
            };
           
            return View();
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        
        public IActionResult Create(CreatePostVM request)
        {
           
            if (ModelState.IsValid)
            {
                //1. add tag vao database
                var tagIds = this._unitOfWork.TagRepository.AddTagByString(request.Tags);
                // 2. create postTag
                var postTags = new List<PostTagMap>();
                foreach (var tagId in tagIds)
                {
                    var postTag = new PostTagMap()
                    {
                        TagId = tagId
                    };
                    postTags.Add(postTag);
                }
                var post = new Post()
                {
                    Title = request.Title,
                    UrlSlug = SeoUrlHepler.FrientlyUrl(request.Title),
                    PostContent = request.PostContent,
                    CategoryId = request.CategoryId,
                    ShortDescription = request.ShortDescription,
                    PostTagMap = postTags
                };
                this._unitOfWork.PostRepository.Add(post);
                _unitOfWork.SaveChange();
                TempData["success"] = "Post created successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Post created error";
            ViewBag.CategoryList = _unitOfWork.CategoryRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Name,
                Value = i.Id.ToString()
            });
            ViewBag.PublishedList = new List<SelectListItem>()
            {
                new SelectListItem() { Text = "True", Value = true.ToString(), Selected=true },
                new SelectListItem() { Text = "False", Value = false.ToString(), Selected=false },
            };
            return View(request);
        }

        //GET
        public IActionResult Edit(int? id)
        {

            if (id.Value == null || id.Value == 0)
            {
                return NotFound();
            }
            var PostFromDbFirst = _unitOfWork.PostRepository.GetById(id.Value);
            if (PostFromDbFirst == null)
            {
                return NotFound();
            }
            UpdatePostVM updatePostVM = new UpdatePostVM()
            {
                Post = PostFromDbFirst,
                CategoryList = new SelectList(_unitOfWork.CategoryRepository.GetAll(), "Id", "Name", PostFromDbFirst.CategoryId),
                TagList =string.Join("; ", _unitOfWork.TagRepository.GetTagsByPost(id.Value).Select(x=>x.Name)) 
            };
            ViewBag.PublishedList = new List<SelectListItem>()
            {
                new SelectListItem() { Text = "True", Value = true.ToString(), Selected=true },
                new SelectListItem() { Text = "False", Value = false.ToString(), Selected=false },
            };
            return View(updatePostVM);
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        
        public IActionResult Edit(UpdatePostVM obj)
        {
           
            if (ModelState.IsValid)
            {
                //1. add tag vao database
                var tagIds = this._unitOfWork.TagRepository.AddTagByString(obj.TagList);
               //2. delete post tag
              var postTagDeletes= _unitOfWork.JustBlogContext.PostTagMap.Where(x => x.PostId == obj.Post.Id);
                foreach (var postTagMap in postTagDeletes)
                {
                    _unitOfWork.JustBlogContext.PostTagMap.Remove(postTagMap);
                }
                _unitOfWork.SaveChange();
                // 3. create postTag
                var postTags = new List<PostTagMap>();
                foreach (var tagId in tagIds)
                {
                    var postTag = new PostTagMap()
                    {
                        PostId= obj.Post.Id,
                        TagId = tagId
                    };
                    postTags.Add(postTag);
                }
                _unitOfWork.JustBlogContext.PostTagMap.AddRange(postTags);
                obj.Post.PostTagMap = postTags;
                obj.Post.UrlSlug = SeoUrlHepler.FrientlyUrl(obj.Post.Title);
                _unitOfWork.PostRepository.Update(obj.Post);
                _unitOfWork.SaveChange();
                TempData["success"] = "Post updated successfully";
                return RedirectToAction("Index");
            }
            obj.CategoryList = new SelectList(_unitOfWork.CategoryRepository.GetAll(), "Id", "Name", obj.Post.CategoryId);
            TempData["error"] = "Post Edit error";
            return View(obj);
        }

      

        #region API CALLS
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var productList = _unitOfWork.PostRepository.GetAll(includeProperties:"Category");
            switch (status)
            {
                case "latest":
                    productList = _unitOfWork.PostRepository.GetLatestPost(10);
                    break;
                case "mostViewed":
                    productList = _unitOfWork.PostRepository.GetMostViewedPost(10);
                    break;
                case "mostInteresting":
                    productList = _unitOfWork.PostRepository.GetHighestPosts(10);
                    break;
                case "published":
                    productList = _unitOfWork.PostRepository.GetPublisedPosts();
                    break;
                case "unPublished":
                    productList = _unitOfWork.PostRepository.GetUnpublisedPosts();
                    break;
                default:
                    break;
            }
            return Json(new { data = productList });
        }
        [Authorize(Roles = SD.Role_Blog_Owner)]
        //POST
        [HttpDelete]
        public IActionResult Delete(int? id)
        {
            var obj = _unitOfWork.PostRepository.GetById(id.Value);
            if (obj == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.PostRepository.Delete(obj);
            _unitOfWork.SaveChange();
            return Json(new { success = true, message = "Delete Successful" });

        }
       
      
        [HttpPost]
        public JsonResult AutoComplete(string Prefix)
        {
            var names = _unitOfWork.TagRepository.GetAll().Where(p => p.Name.Contains(Prefix)).Select(p => p.Name).ToList();

            return Json(names);
        }
        #endregion

    }
}

FA.JustBlog/FA.JustBlog.Web/Areas/Customer/Controllers/CategoryController.cs
using FA.JustBlog.Core.Infrastructures;
using Microsoft.AspNetCore.Mvc;

namespace FA.JustBlog.Web.Areas.Customer.Controllers
{
    [Area("Customer")]
    public class CategoryController : Controller
    {
        private readonly IUnitOfWork unitOfWork;

        public CategoryController(IUnitOfWork unitOfWork)
        {
            this.unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {
            return View();
        }
    }
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Categories/Create.cshtml
@model Category
@{
    ViewData["Title"] = "";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
	
}
<form method="post"  asp-action="Create" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
	<div class="border p-3 mt-4" >
		<div class="row pb-6">
			<h2 class="text-primary">Create Category</h2>
			<hr />
		</div>
		@*<div asp-validation-summary="All"></div>*@
		<div class="mb-3">
			<label asp-for="Name"></label>
			<input asp-for="Name" class="form-control" onchange="myFunction()" />
			<span asp-validation-for="Name" class="text-danger"></span>
		</div>
		
		<div class="mb-3">
			<label asp-for="Description"></label>
			<textarea asp-for="Description" rows="3" class="form-control"></textarea>
			<span asp-validation-for="Description" class="text-danger"></span>
		</div>
		<button type="submit" class="btn btn-primary" style="width:150px">Create</button>
		<a asp-controller="Posts" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to List
		</a>
	</div>
</form>

@section Scripts{
	@{
		<partial name="_ValidationScriptsPartial" />
	}
	<script>
    tinymce.init({
      selector: 'textarea',
      plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
      toolbar_mode: 'floating',
   });
  
	function ValidateInput(){
		if(document.getElementById("uploadBox").value==""){
			Swal.fire({
			  icon: 'error',
			  title: 'Oops...',
			  text: 'Please upload an Image!',
			});
			return false;
		}
		return true;
	}
</script>
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Categories/Edit.cshtml
@model Category
@{
    ViewData["Title"] = "";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
}

<form method="post" asp-action="Edit" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
    <div class="border p-3 mt-4">
        <div class="row pb-6">
            <h2 class="text-primary">Edit category</h2>
            <hr />
        </div>
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>
        <input type="hidden" asp-for="Id" />
        <div class="mb-3">
            <label asp-for="Name" class="control-label"></label>
            <input asp-for="Name" class="form-control" />
            <span asp-validation-for="Name" class="text-danger"></span>
        </div>
      
        <div class="mb-3">
            <label asp-for="Description" class="control-label"></label>
            <textarea asp-for="Description" rows="3" class="form-control"></textarea>
            <span asp-validation-for="Description" class="text-danger"></span>
        </div>
        <div class="mb-3">
            <label asp-for="UrlSlug" class="control-label"></label>
            <input asp-for="UrlSlug" class="form-control" disabled />
            <span asp-validation-for="UrlSlug" class="text-danger"></span>
        </div>
       
        <div class="mb-3">
            <input type="submit" value="Save" class="btn btn-primary" />
        </div>
    </div>
</form>


<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts{
	@{
    <partial name="_ValidationScriptsPartial" />
	}
<script>
     tinymce.init({
       selector: 'textarea',
       plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
       toolbar_mode: 'floating',
    });

     function ValidateInput(){
         if(document.getElementById("uploadBox").value==""){
             Swal.fire({
               icon: 'error',
               title: 'Oops...',
               text: 'Please upload an Image!',
             });
             return false;
         }
         return true;
     }
</script>
}

FA.JustBlog/FA.JustBlog.Web/Areas/Admin/Views/Categories/Index.cshtml
@{
    ViewData["Title"] = "";
}
    <div class="container p-3">
        <div class="row pt-4">
            <div class="col-6">
                <h2 class="text-primary">Category List</h2>
            </div>
            <div class="col-6 text-end">
                <a asp-controller="Categories" asp-action="Create" class="btn btn-primary">
                    <i class="bi bi-plus-circle"></i> &nbsp; Create New Category
                </a>
            </div>
        </div>
        <br /><br />

        <table id="tblData" class="table table-bPostsed table-striped" style="width:100%">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>UrlSlug</th>
                    <th>Description</th>
                    <th></th>
                </tr>
            </thead>
        </table>
    </div>

@section scripts{
    <script src="~/js/category.js"></script>
}